package com.nisum.basicFlowExample;


import java.util.concurrent.SubmissionPublisher;


public class Sample {
    public static void main(String[] args) throws InterruptedException {

        //Flow.Publisher<Integer> feed=new SubmissionPublisher<>();  //using this submit will have a prblm

        //Creating a publisher
        SubmissionPublisher<Integer> feed=new SubmissionPublisher<>();


        MessageSubscriber messageSubscriber=new MessageSubscriber();
        PrintSubscriber printSubscriber=new PrintSubscriber();
        EventSubscriber eventSubscriber=new EventSubscriber();

        feed.subscribe(messageSubscriber);
        feed.subscribe(printSubscriber);
        feed.subscribe(eventSubscriber);


       for (int i = 0; i < 10; i++) {
            feed.submit(i);            //submit is not a method of publisher....its a part of submission publisher //asynchronously pushed to subscribers
            //feed.submit(i*2);    //transforming data while publishing itself
        }


       //When Subscription is cancelled from one of the subscribers
        /*int count = 0;
        while(count < 20) {
            Thread.sleep(500);
            if(!feed.hasSubscribers()) {
                System.out.println("Subscription is removed:  as we are getting more than 5");
                break;
            }
            int result=count++;
            feed.submit(result);
        }*/


        sleep(1000);
    }

    private static Boolean sleep(int ms) {
        try{
            Thread.sleep(ms);
            return true;
        }
        catch(InterruptedException e){
            return false;
        }
    }


}
